/* This file is automatically generated from the documentation. EDIT AT YOUR OWN RISK. */

#ifndef PROOT_CLI_H
#define PROOT_CLI_H

#include "cli/cli.h"

#ifndef VERSION
#define VERSION "5.4.0"
#endif

static const char *recommended_bindings[] = {
	"/etc/host.conf",
	"/etc/hosts",
	"/etc/hosts.equiv",
	"/etc/mtab",
	"/etc/netgroup",
	"/etc/networks",
	"/etc/passwd",
	"/etc/group",
	"/etc/nsswitch.conf",
	"/etc/resolv.conf",
	"/etc/localtime",
	"/dev/",
	"/sys/",
	"/proc/",
	"/tmp/",
	"/run/",
	"/var/run/dbus/system_bus_socket",
	"$HOME",
	"path",
	NULL,
};

static const char *recommended_su_bindings[] = {
	"/etc/host.conf",
	"/etc/hosts",
	"/etc/nsswitch.conf",
	"/etc/resolv.conf",
	"/dev/",
	"/sys/",
	"/proc/",
	"/tmp/",
	"/run/shm",
	"$HOME",
	"path",
	NULL,
};

static int handle_option_r(Tracee *tracee, const Cli *cli, const char *value);
static int handle_option_b(Tracee *tracee, const Cli *cli, const char *value);
static int handle_option_q(Tracee *tracee, const Cli *cli, const char *value);
static int handle_option_w(Tracee *tracee, const Cli *cli, const char *value);
static int handle_option_v(Tracee *tracee, const Cli *cli, const char *value);
static int handle_option_V(Tracee *tracee, const Cli *cli, const char *value);
static int handle_option_h(Tracee *tracee, const Cli *cli, const char *value);
static int handle_option_k(Tracee *tracee, const Cli *cli, const char *value);
static int handle_option_0(Tracee *tracee, const Cli *cli, const char *value);
static int handle_option_i(Tracee *tracee, const Cli *cli, const char *value);
static int handle_option_p(Tracee *tracee, const Cli *cli, const char *value);
static int handle_option_n(Tracee *tracee, const Cli *cli, const char *value);
static int handle_option_R(Tracee *tracee, const Cli *cli, const char *value);
static int handle_option_S(Tracee *tracee, const Cli *cli, const char *value);

static int pre_initialize_bindings(Tracee *, const Cli *, size_t, char *const *, size_t);
static int post_initialize_command(Tracee *, const Cli *, size_t, char *const *, size_t);

static Cli proot_cli = {
	.version  = VERSION,
	.name     = "proot",
	.subtitle = "chroot, mount --bind, and binfmt_misc without privilege/setup",
	.synopsis = "proot [option] ... [command]",
	.colophon = "Visit https://proot-me.github.io for help, bug reports, suggestions, patches, ...
Copyright (C) 2023 PRoot Developers, licensed under GPL v2 or later.",
	.logo = "\
 _____ _____              ___
|  __ \  __ \_____  _____|   |_
|   __/     /  _  \/  _  \    _|
|__|  |__|__\_____/\_____/\____|",

	.pre_initialize_bindings = pre_initialize_bindings,
	.post_initialize_command = post_initialize_command,

	.options = {
	{ .class = "Regular options",
	  .arguments = {
		{ .name = "-r", .separator = ' ', .value = "path" },
		{ .name = "--rootfs", .separator = '=', .value = "path" },
		{ .name = NULL, .separator = '\0', .value = NULL } },
	  .handler = handle_option_r,
	  .description = "Use *path* as the new guest root file-system, default is /.",
	  .detail = "The specified path typically contains a Linux distribution where
all new programs will be confined.  The default rootfs is /
when none is specified, this makes sense when the bind mechanism
is used to relocate host files and directories, see the -b
option and the Examples section for details.

It is recommended to use the -R or -S options instead.

",
	},
	{ .class = "Regular options",
	  .arguments = {
		{ .name = "-b", .separator = ' ', .value = "path" },
		{ .name = "--bind", .separator = '=', .value = "path" },
		{ .name = "-m", .separator = ' ', .value = "path" },
		{ .name = "--mount", .separator = '=', .value = "path" },
		{ .name = NULL, .separator = '\0', .value = NULL } },
	  .handler = handle_option_b,
	  .description = "Make the content of *path* accessible in the guest rootfs.",
	  .detail = "This option makes any file or directory of the host rootfs
accessible in the confined environment just as if it were part of
the guest rootfs.  By default the host path is bound to the same
path in the guest rootfs but users can specify any other location
with the syntax: -b *host_path*:*guest_location*.  If the
guest location is a symbolic link, it is dereferenced to ensure
the new content is accessible through all the symbolic links that
point to the overlaid content.  In most cases this default
behavior shouldn't be a problem, although it is possible to
explicitly not dereference the guest location by appending it the
! character: -b *host_path*:*guest_location!*.

",
	},
	{ .class = "Regular options",
	  .arguments = {
		{ .name = "-q", .separator = ' ', .value = "command" },
		{ .name = "--qemu", .separator = '=', .value = "command" },
		{ .name = NULL, .separator = '\0', .value = NULL } },
	  .handler = handle_option_q,
	  .description = "Execute guest programs through QEMU as specified by *command*.",
	  .detail = "Each time a guest program is going to be executed, PRoot inserts
the QEMU user-mode command in front of the initial request.
That way, guest programs actually run on a virtual guest CPU
emulated by QEMU user-mode.  The native execution of host programs
is still effective and the whole host rootfs is bound to
/host-rootfs in the guest environment.

",
	},
	{ .class = "Regular options",
	  .arguments = {
		{ .name = "-w", .separator = ' ', .value = "path" },
		{ .name = "--pwd", .separator = '=', .value = "path" },
		{ .name = "--cwd", .separator = '=', .value = "path" },
		{ .name = NULL, .separator = '\0', .value = NULL } },
	  .handler = handle_option_w,
	  .description = "Set the initial working directory to *path*.",
	  .detail = "Some programs expect to be launched from a given directory but do
not perform any chdir by themselves.  This option avoids the
need for running a shell and then entering the directory manually.

",
	},
	{ .class = "Regular options",
	  .arguments = {
		{ .name = "-v", .separator = ' ', .value = "value" },
		{ .name = "--verbose", .separator = '=', .value = "value" },
		{ .name = NULL, .separator = '\0', .value = NULL } },
	  .handler = handle_option_v,
	  .description = "Set the level of debug information to *value*.",
	  .detail = "The higher the integer value is, the more detailed debug
information is printed to the standard error stream.  A negative
value makes PRoot quiet except on fatal errors.

",
	},
	{ .class = "Regular options",
	  .arguments = {
		{ .name = "-V", .separator = '\0', .value = NULL },
		{ .name = "--version", .separator = '\0', .value = NULL },
		{ .name = "--about", .separator = '\0', .value = NULL },
		{ .name = NULL, .separator = '\0', .value = NULL } },
	  .handler = handle_option_V,
	  .description = "Print version, copyright, license and contact, then exit.",
	  .detail = "",
	},
	{ .class = "Regular options",
	  .arguments = {
		{ .name = "-h", .separator = '\0', .value = NULL },
		{ .name = "--help", .separator = '\0', .value = NULL },
		{ .name = "--usage", .separator = '\0', .value = NULL },
		{ .name = NULL, .separator = '\0', .value = NULL } },
	  .handler = handle_option_h,
	  .description = "Print the version and the command-line usage, then exit.",
	  .detail = "",
	},
	{ .class = "Extension options",
	  .arguments = {
		{ .name = "-k", .separator = ' ', .value = "string" },
		{ .name = "--kernel-release", .separator = '=', .value = "string" },
		{ .name = NULL, .separator = '\0', .value = NULL } },
	  .handler = handle_option_k,
	  .description = "Make current kernel appear as kernel release *string*.",
	  .detail = "If a program is run on a kernel older than the one expected by its
GNU C library, the following error is reported: \"FATAL: kernel too
old\".  To be able to run such programs, PRoot can emulate some of
the features that are available in the kernel release specified by
string but that are missing in the current kernel.

",
	},
	{ .class = "Extension options",
	  .arguments = {
		{ .name = "-0", .separator = '\0', .value = NULL },
		{ .name = "--root-id", .separator = '\0', .value = NULL },
		{ .name = NULL, .separator = '\0', .value = NULL } },
	  .handler = handle_option_0,
	  .description = "Make current user appear as \"root\" and fake its privileges.",
	  .detail = "Some programs will refuse to work if they are not run with \"root\"
privileges, even if there is no technical reason for that.  This
is typically the case with package managers.  This option allows
users to bypass this kind of limitation by faking the user/group
identity, and by faking the success of some operations like
changing the ownership of files, changing the root directory to
/, ...  Note that this option is quite limited compared to
fakeroot.

",
	},
	{ .class = "Extension options",
	  .arguments = {
		{ .name = "-i", .separator = ' ', .value = "string" },
		{ .name = "--change-id", .separator = '=', .value = "string" },
		{ .name = NULL, .separator = '\0', .value = NULL } },
	  .handler = handle_option_i,
	  .description = "Make current user and group appear as *string* \"uid:gid\".",
	  .detail = "This option makes the current user and group appear as uid and
gid.  Likewise, files actually owned by the current user and
group appear as if they were owned by uid and gid instead.
Note that the -0 option is the same as -i 0:0.

",
	},
	{ .class = "Extension options",
	  .arguments = {
		{ .name = "-p", .separator = ' ', .value = "string" },
		{ .name = "--port", .separator = '=', .value = "string" },
		{ .name = NULL, .separator = '\0', .value = NULL } },
	  .handler = handle_option_p,
	  .description = "Map ports to others with the syntax as *string* \"port_in:port_out ...\".",
	  .detail = "This option makes PRoot intercept bind and connect system calls,
and change the port they use. The port map is specified
with the syntax: -b *port_in*:*port_out*. For example,
an application that runs a MySQL server binding to 5432 wants
to cohabit with other similar application, but doesn't have an
option to change its port. PRoot can be used here to modify
this port: proot -p 5432:5433 myapplication. With this command,
the MySQL server will be bound to the port 5433.
This command can be repeated multiple times to map multiple ports.

",
	},
	{ .class = "Extension options",
	  .arguments = {
		{ .name = "-n", .separator = '\0', .value = NULL },
		{ .name = "--netcoop", .separator = '\0', .value = NULL },
		{ .name = NULL, .separator = '\0', .value = NULL } },
	  .handler = handle_option_n,
	  .description = "Activates the network cooperation mode.",
	  .detail = "This option makes PRoot intercept bind() system calls and
change the port they are binding to to 0. With this, the system will
allocate an available port. Each time this is done, a new entry is added
to the port mapping entries, so that corresponding connect() system calls
use the same resulting port.

",
	},
	{ .class = "Alias options",
	  .arguments = {
		{ .name = "-R", .separator = ' ', .value = "path" },
		{ .name = NULL, .separator = '\0', .value = NULL } },
	  .handler = handle_option_R,
	  .description = "Alias: -r *path* + a couple of recommended -b.",
	  .detail = "Programs isolated in path, a guest rootfs, might still need to
access information about the host system, as it is illustrated in
the Examples section of the manual.  These host information
are typically: user/group definition, network setup, run-time
information, users' files, ...  On all Linux distributions, they
all lie in a couple of host files and directories that are
automatically bound by this option:

",
	},
	{ .class = "Alias options",
	  .arguments = {
		{ .name = "-S", .separator = ' ', .value = "path" },
		{ .name = NULL, .separator = '\0', .value = NULL } },
	  .handler = handle_option_S,
	  .description = "Alias: -0 -r *path* + a couple of recommended -b.",
	  .detail = "This option is useful to safely create and install packages into
the guest rootfs.  It is similar to the -R option except it
enables the -0 option and binds only the following minimal set
of paths to avoid unexpected changes on host files:

",
	},
	END_OF_OPTIONS,
	},
};

#endif /* PROOT_CLI_H */
